﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace GraphApp
{
    static class ExpressionExtention
    {
        public static void Accept(this Expression expr, IVisitor visitor)
        {
            if (expr is BinaryExpression)
            {
                visitor.Visit((BinaryExpression)expr);
                return;
            }
            if (expr is ConditionalExpression)
            {
                visitor.Visit((ConditionalExpression)expr);
                return;
            }
            if (expr is ConstantExpression)
            {
                visitor.Visit((ConstantExpression)expr);
                return;
            }
            if (expr is InvocationExpression)
            {
                visitor.Visit((InvocationExpression)expr);
                return;
            }
            if (expr is LambdaExpression)
            {
                visitor.Visit((LambdaExpression)expr);
                return;
            }
            if (expr is ListInitExpression)
            {
                visitor.Visit((ListInitExpression)expr);
                return;
            }
            if (expr is MemberExpression)
            {
                visitor.Visit((MemberExpression)expr);
                return;
            }
            if (expr is MemberInitExpression)
            {
                visitor.Visit((MemberInitExpression)expr);
                return;
            }
            if (expr is MethodCallExpression)
            {
                visitor.Visit((MethodCallExpression)expr);
                return;
            }
            if (expr is NewArrayExpression)
            {
                visitor.Visit((NewArrayExpression)expr);
                return;
            }
            if (expr is NewExpression)
            {
                visitor.Visit((NewExpression)expr);
                return;
            }
            if (expr is ParameterExpression)
            {
                visitor.Visit((ParameterExpression)expr);
                return;
            }
            if (expr is TypeBinaryExpression)
            {
                visitor.Visit((TypeBinaryExpression)expr);
                return;
            }
            if (expr is UnaryExpression)
            {
                visitor.Visit((UnaryExpression)expr);
                return;
            }
            visitor.Visit(expr);
        }
    }
}
